/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "includes.h"

/*
	Remake so it will just have a few set of functions for the user?
	Like:
	AddTriggerFromEksParentStruct(EksParent *par)
	DeleteTriggerFromEksParentStruct(EksParent *par,EksParent *del)
	???
*/

/**
	When the user clicks on a option in the menu-list
	like (collision).

	@param widget NO_FREE
		the menu list item
	@param data → (char*) NO_FREE
		string with condition
	@return
		void

	@param globals ConWindow ← remove?
*/
void haed_trigger_conditions_add(GtkWidget *widget,gpointer data)
{
	EksParent *condition;
	
	EksParent *tempObject=HAED_GLOBAL_TEMP_HAEDOBJECT;
	EksParent *otherObject=NULL;
	char *otherString=NULL;
	
	char *ConditionString;
	char *ConditionType=(char*)data;
	
	b_debug_message("condition type: %s\n",ConditionType);
	
	//collision
	if(ConditionType==_AO_COLLISION_)
	{
		otherObject=GetObjectFromSelection();
		
		ConditionString=g_strdup_printf("%s(%s,%s)",ConditionType,tempObject->name,otherObject->name);
	}
	//pick count
	else if(ConditionType==_AO_COUNT_)
	{
		char *operator;
	
		otherString=haed_window_compare_field(&operator);
		
		ConditionString=g_strdup_printf("%s(%s) %s %s",ConditionType,tempObject->name,operator,otherString);
	}
	//pick count
	else if(strcmp(ConditionType,_SPECIAL_TIMER_)==0)
	{
		char *operator;
	
		otherString=haed_window_compare_field(&operator);
		
		//b_tm("GOT HERE");
		//temp
		ConditionString=g_strdup_printf("ANIMATION_ROLLER %s %s",operator,otherString);
		
		//b_tm("GOT HERE");
	}
	else if(strcmp(ConditionType,_SPECIAL_C_COMMAND_)==0)
	{
		ConditionString="1";
	}
	else
	{
		otherString=EnterCode();
		
		ConditionString=g_strdup_printf("%s(%s)",ConditionType,otherString);
	}
	
	condition=haed_triggerparent_add_condition(0,ConditionString);
	//NewConditionAdd(condition);
	
	haed_triggers_insert_row(HAED_GLOBAL_TRIGGER_GRID,condition);
	//see popup windows
	gtk_widget_destroy(ConWindow);
}

//==============ACTIONS===============

/**
	Standardfunction when the user clicks on a action to select.
	@param see OnAOButtonActionSelect

	@param widget NO_FREE
		the menu field
	@param data → (char*)
		The action string
	@return
		void
*/
void haed_trigger_actions_add(GtkWidget *widget,gpointer data)
{
	char *actionText;
	
	char *actiontype=(char*)data;
	char *actionString=NULL;
	
	GtkWidget *tempWidget=HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton;
	EksParent *tempObject=g_object_get_data(G_OBJECT(tempWidget),"haed_object");
	EksParent *tempCondition=g_object_get_data(G_OBJECT(tempWidget),"haed_condition");
	
	b_tm("%s",tempObject->name);
	
	//only using the object
	if(strcmp(actiontype,_AO_STOP_)==0 || strcmp(actiontype,_AO_BOUNCE_)==0 || strcmp(actiontype,_AO_DESTROY_)==0)
	{
		actionString=g_strdup_printf("%s(%s)",actiontype,tempObject->name);
	}
	//enter number
	else if(strcmp(actiontype,_AO_SETX_)==0 || strcmp(actiontype,_AO_SETY_)==0)
	{
		char *otherString=EnterCode();
		
		actionString=g_strdup_printf("%s(%s,%s)",actiontype,tempObject->name,otherString);
		free(otherString);
	}
	//select x,y (at level editor)
	else if(strcmp(actiontype,_AO_CREATE_)==0)
	{
		char *otherString1=EnterCode();
		char *otherString2=EnterCode();
		
		actionString=g_strdup_printf("%s(%s,%s,%s)",actiontype,tempObject->name,otherString1,otherString2);
		free(otherString1);
		free(otherString2);
	}
	//noting only the action string
	else if(strcmp(actiontype,_RESTART_PROGRAM_)==0 || strcmp(actiontype,_RESTART_LEVEL_)==0)
	{
		actionString=g_strdup_printf("%s",actiontype);
	}
	else if(strcmp(actiontype,_NEXT_LEVEL_)==0)
	{
		actionString=g_strdup_printf("%s()",actiontype);
	}
	//select level
	else if(strcmp(actiontype,_SET_LEVEL_)==0)
	{
		char *otherString=haed_pick_level_dialog();
		
		actionString=g_strdup_printf("%s(%s)",actiontype,otherString);
		free(otherString);
	}
	
	//åäöpyfgcrl
	if((actionText=haed_triggerparent_add_action(tempCondition,actionString)))
	{
		haed_triggers_add_visual_for_action(tempWidget,actionText);
	}
	//NewConditionAdd(NewConditionText);
	
	//HAED_GLOBAL_ACTION_INF=NULL;
}

void trigger_conditions_special(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	//the menu list
	GtkMenuListInner conditionList[]=
	{
		{"Timing",NULL,NULL,
		(GtkMenuListInner[]){
			{"Get game ticks",haed_trigger_conditions_add,_SPECIAL_TIMER_},
			{"Is a timer a certain value",haed_trigger_conditions_add,_SPECIAL_TIMER_}
		},2},
		{"Custom C command",haed_trigger_conditions_add,_SPECIAL_C_COMMAND_}
	};
	
	//set global value
	HAED_GLOBAL_TEMP_HAEDOBJECT=(EksParent*)data;
	haed_triggers_create_popup_from_menu_list(conditionList,sizeof(conditionList)/sizeof(conditionList[0]),event);
}

void trigger_conditions_sound(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	//the menu list
	GtkMenuListInner conditionList[]=
	{
		{"Samples",NULL,NULL,
		(GtkMenuListInner[]){
			{"Is a sample not playing?",NULL,NULL},
			{"Is a specific sample not playing?",NULL,NULL}
		},2},
		{"Music",NULL,NULL,
		(GtkMenuListInner[]){
			{"Is a music not playing?",NULL,NULL},
			{"Is a specific music not playing?",NULL,NULL}
		},2}
	};
	
	//set global value
	HAED_GLOBAL_TEMP_HAEDOBJECT=(EksParent*)data;
	haed_triggers_create_popup_from_menu_list(conditionList,sizeof(conditionList)/sizeof(conditionList[0]),event);
}

void trigger_conditions_storyboard(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	//the menu list
	GtkMenuListInner conditionList[]=
	{
		{"End of level",NULL,NULL},
		{"Start of level",NULL,NULL},
		{"End game",NULL,NULL}
	};
	
	//set global value
	HAED_GLOBAL_TEMP_HAEDOBJECT=(EksParent*)data;
	haed_triggers_create_popup_from_menu_list(conditionList,sizeof(conditionList)/sizeof(conditionList[0]),event);
}
void trigger_conditions_input(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	//the menu list
	GtkMenuListInner conditionList[]=
	{
		{"Read input state",NULL,NULL,
		(GtkMenuListInner[]){
			{"Is a button pressed down",NULL,NULL},
			{"Is a button up",NULL,NULL},
			{"Read input state ...",NULL,NULL}
		},3}
	};
	
	//set global value
	HAED_GLOBAL_TEMP_HAEDOBJECT=(EksParent*)data;
	haed_triggers_create_popup_from_menu_list(conditionList,sizeof(conditionList)/sizeof(conditionList[0]),event);
}

/**
	Creates the popup menu to select conditon

	@param widget NO_FREE
		the widget the user hovers
	@param event NO_FREE
		what happens
	@param data → (EksParent*) NO_FREE
		some inf to send
	@return
		void
*/
void trigger_conditions_active_object(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	//the menu list
	GtkMenuListInner conditionList[]=
	{
		{"Collisions",NULL,NULL,
		(GtkMenuListInner[]){
			{"Another object",haed_trigger_conditions_add,_AO_COLLISION_},
			{"Overlapping another object",NULL,NULL},
			{"Backdrop",NULL,NULL},
			{"Overlapping a backdrop",NULL,NULL}
		},4},
		{"Movement",NULL,NULL,
		(GtkMenuListInner[]){
			{"Stopped",NULL,NULL},
			{"Bouncing",NULL,NULL},
			{"Compare speed to value",NULL,NULL},
			{"Compare acceleration to value",NULL,NULL},
			{"Compare deacceleration to value",NULL,NULL}
		},5},
		{"Animation",NULL,NULL,
		(GtkMenuListInner[]){
			{"Animation is playing",NULL,NULL},
			{"Animation finnished",NULL,NULL},
			{"Compare animation value",NULL,NULL}
		},3},
		{"Position",NULL,NULL,
		(GtkMenuListInner[]){
			{"Raw Position in level",NULL,NULL},
			{"Getting closer to the levels edge",NULL,NULL},
			{"Compare x position",NULL,NULL},
			{"Compare y position",NULL,NULL}
		},4},
		{"Direction",NULL,NULL,
		(GtkMenuListInner[]){
			{"Compare direction of object",NULL,NULL}
		},1},
		{"Visibility",NULL,NULL,
		(GtkMenuListInner[]){
			{"Is visible",NULL,NULL}
		},1},
		{"Pick or Count",NULL,NULL,
		(GtkMenuListInner[]){
			{"Pick one at random",NULL,NULL},
			{"Number of objects",haed_trigger_conditions_add,_AO_COUNT_},
			{"Number of objects in zone",NULL,NULL}
		},3},
		{"Values",NULL,NULL,
		(GtkMenuListInner[]){
			{"Get value",NULL,NULL},
			{"Get flag",NULL,NULL}
		},2}
	};
	
	//set global value
	HAED_GLOBAL_TEMP_HAEDOBJECT=(EksParent*)data;
	haed_triggers_create_popup_from_menu_list(conditionList,sizeof(conditionList)/sizeof(conditionList[0]),event);
}

/**
	Remove the current action and show it

	@param widget
		irrelevant
	@param data
		also irrelevant
*/
void haed_triggers_remove_action(GtkWidget *widget,gpointer data)
{
	b_debug_message("REMOVING ACTION");
	
	EksParent *conditionEksParent=g_object_get_data(G_OBJECT(HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton),"haed_condition");;
	GtkWidget *currentWidget=HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton;
	
	if(conditionEksParent==NULL)
	{
		b_error_message("ERROR ON REMOVING ACTION!");
	}
	else
	{
		b_tm("GOT HERE %s",gtk_widget_get_tooltip_text(currentWidget));
	
		size_t numberOfChildsAfterRemoval=0;
		
		char **explodedString=g_strsplit(gtk_widget_get_tooltip_text(currentWidget),"\n",0);

		int explodelen=0,doNexUnit=0;
		
		if(explodedString!=NULL)
		{
			while(explodedString[explodelen]!=NULL){
				b_tm("EXPLODED STRING %d %s",explodelen,explodedString[explodelen]);
				explodelen++;
			}
		}

		char *infotext=NULL;
		
		int destroyed=0;
		
		EksParent *firstUnit=conditionEksParent->firstChild;

		if(!firstUnit)
			return;
	
		b_tm("GOT HERE %d",explodelen);
	
		EksParent *loopUnit=firstUnit;
		EksParent *sloopUnit;

		do
		{
			doNexUnit=0;
			sloopUnit=loopUnit->nextChild;
			
			char *curChildName=eks_parent_get_string(loopUnit);
			
			for(int j=0;j<explodelen;j++)
			{
				b_tm("Match: %s,%s",curChildName,explodedString[j]);
		
				if(strcmp(curChildName,explodedString[j])==0)
				{
					if(destroyed==0 && j==0)
					{
						b_tm("REMOVING: %s",loopUnit->name);
						eks_parent_destroy(loopUnit,EKS_TRUE);
						numberOfChildsAfterRemoval=explodelen-1;
						
						b_tm("NUM: %ld",numberOfChildsAfterRemoval);
						
						if(numberOfChildsAfterRemoval<=0)
						{
							gtk_button_set_label(GTK_BUTTON(currentWidget)," ");
							gtk_widget_set_tooltip_text(currentWidget,NULL);
							
							return;
						}
						
						destroyed++;
						
						if(conditionEksParent->firstChild!=NULL)
						{
							firstUnit=conditionEksParent->firstChild->prevChild;
							loopUnit=conditionEksParent->firstChild;
						}
						else
							return;
						
						doNexUnit=1;
						
						goto do_next_object;
					}
					else
					{
						size_t textlen=strlen(curChildName);
					
						size_t itextlen=infotext?strlen(infotext):0;
	
						int isNotLast=(destroyed-1<(numberOfChildsAfterRemoval-1));
	
						if(infotext)
							infotext=realloc(infotext,textlen+itextlen+1+isNotLast);
						else
							infotext=malloc(textlen+itextlen+1+isNotLast);
		
						memcpy(infotext+itextlen,curChildName,textlen);
		
						if(isNotLast)
						{
							infotext[textlen+itextlen]='\n';
							infotext[textlen+itextlen+1]='\0';
						}
						else
							infotext[textlen+itextlen]='\0';
		
						b_tm("mess=%s %s",infotext,curChildName);
						
						destroyed++;
					}
				}
			}
			
			do_next_object:

			loopUnit=sloopUnit;
		}while(loopUnit!=firstUnit || doNexUnit==1);
		
		gtk_widget_set_tooltip_text(currentWidget,infotext);
	}
}

/**
	Creates the popup menu to select action

	@param widget NO_FREE
		the widget the user hovers
	@param event NO_FREE
		what happens
	@param data
	@return
		void
*/
void OnAOButtonActionSelect(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	GtkMenuListInner placedObject;
	
	HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton=widget;
	
	if(strcmp("X",gtk_button_get_label(GTK_BUTTON(widget)))==0)
	{
		placedObject=(GtkMenuListInner){"Remove action",haed_triggers_remove_action,NULL};
	}
	else
	{
		placedObject=(GtkMenuListInner){NULL,NULL,NULL};
	}
	
	//the menu list
	GtkMenuListInner actionList[]=
	{
		{"Movement",NULL,NULL,
		(GtkMenuListInner[]){
			{"Stop",haed_trigger_actions_add,_AO_STOP_},
			{"Start",NULL,NULL},
			{"Bounce",haed_trigger_actions_add,_AO_BOUNCE_},
			{"Warp around level",NULL,NULL},
			{"Set speed",NULL,NULL},
			{"Set maximum speed",NULL,NULL},
			{"Reverse",NULL,NULL}
		},7},
		{"Animation",NULL,NULL,
		(GtkMenuListInner[]){
			{"Set animation to ...",NULL,NULL},
			{"Set animation frame to ...",NULL,NULL}
		},2},
		{"Position",NULL,NULL,
		(GtkMenuListInner[]){
			{"Set position",NULL,NULL},
			{"Swap position with other object",NULL,NULL},
			{"Set x position",haed_trigger_actions_add,_AO_SETX_},
			{"Set y position",haed_trigger_actions_add,_AO_SETY_}
		},4},
		{"Direction",NULL,NULL,
		(GtkMenuListInner[]){
			{"Set direction",NULL,NULL},
			{"set direction to ...",NULL,NULL}
		},2},
		{"Visibility",NULL,NULL,
		(GtkMenuListInner[]){
			{"Make invisible",NULL,NULL},
			{"Make visible",NULL,NULL}
		},2},
		{"Shoot an object",NULL,NULL},
		{"Create",haed_trigger_actions_add,_AO_CREATE_},
		{"Destroy",haed_trigger_actions_add,_AO_DESTROY_},
		{"Values",NULL,NULL,
		(GtkMenuListInner[]){
			{"Set value",NULL,NULL},
			{"Set flag",NULL,NULL}
		},2},
		placedObject
	};
	
	haed_triggers_create_popup_from_menu_list(actionList,sizeof(actionList)/sizeof(actionList[0]),event);
}

void haed_trigger_actions_special(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	GtkMenuListInner placedObject;
	
	HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton=widget;
	
	if(strcmp("X",gtk_button_get_label(GTK_BUTTON(widget)))==0)
	{
		placedObject=(GtkMenuListInner){"Remove action",haed_triggers_remove_action,NULL};
	}
	else
	{
		placedObject=(GtkMenuListInner){NULL,NULL,NULL};
	}
	
	//the menu list
	GtkMenuListInner actionList[]=
	{
		{"Timing",NULL,NULL,
		(GtkMenuListInner[]){
			{"Set game ticks",NULL,NULL},
			{"Is a timer a certain value",NULL,NULL}
		},2},
		{"Custom C command",NULL,NULL},
		placedObject
	};
	haed_triggers_create_popup_from_menu_list(actionList,sizeof(actionList)/sizeof(actionList[0]),event);
}

void haed_trigger_actions_storyboard(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	GtkMenuListInner placedObject;
	
	HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton=widget;
	
	if(strcmp("X",gtk_button_get_label(GTK_BUTTON(widget)))==0)
	{
		placedObject=(GtkMenuListInner){"Remove action",haed_triggers_remove_action,NULL};
	}
	else
	{
		placedObject=(GtkMenuListInner){NULL,NULL,NULL};
	}
	
	//the menu list
	GtkMenuListInner actionList[]=
	{
		{"Next level",haed_trigger_actions_add,_NEXT_LEVEL_},
		{"Previous level",NULL,NULL},
		{"Jump to level",haed_trigger_actions_add,_SET_LEVEL_},
		{"Restart the current level",haed_trigger_actions_add,_RESTART_LEVEL_},
		{"Restart the game",haed_trigger_actions_add,_RESTART_PROGRAM_},
		{"End the game",NULL,NULL},
		placedObject
	};
	haed_triggers_create_popup_from_menu_list(actionList,sizeof(actionList)/sizeof(actionList[0]),event);
}
